package ru.dbotthepony.kstarbound.defs.item.impl

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.item.api.IHarvestingToolDefinition
import ru.dbotthepony.kstarbound.defs.item.api.IItemDefinition
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.io.json.builder.JsonFlat
import ru.dbotthepony.kvector.vector.Vector2d

@JsonFactory(logMisses = false)
class HarvestingToolPrototype(
	@JsonFlat
	val parent: IItemDefinition,
	override val frames: Int,
	override val animationCycle: Double,
	override val blockRadius: Int,
	override val altBlockRadius: Int = 0,
	override val idleSound: ImmutableList<String> = ImmutableList.of(),
	override val strikeSounds: ImmutableList<String> = ImmutableList.of(),
	override val handPosition: Vector2d,
	override val fireTime: Double,
	override val maxStack: Long = 1L,
) : IItemDefinition by parent, IHarvestingToolDefinition
