package ru.dbotthepony.kstarbound.defs.item.impl

import ru.dbotthepony.kstarbound.defs.item.api.IItemDefinition
import ru.dbotthepony.kstarbound.defs.item.api.ILiquidItem
import ru.dbotthepony.kstarbound.defs.item.api.IMaterialItem
import ru.dbotthepony.kstarbound.io.json.builder.JsonAlias
import ru.dbotthepony.kstarbound.io.json.builder.JsonBuilder
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.io.json.builder.JsonFlat
import ru.dbotthepony.kstarbound.util.Either

@JsonFactory
data class MaterialItemDefinition(
	@JsonFlat
	val parent: IItemDefinition,
	@JsonAlias("materialId", "materialName")
	override val material: Either<Int, String>
) : IMaterialItem, IItemDefinition by parent {
	override val itemType: String
		get() = super<IMaterialItem>.itemType
}
