package ru.dbotthepony.kstarbound.defs.player

import com.google.common.collect.ImmutableMap
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.util.WriteOnce

@JsonFactory
data class InventoryConfig(
	val customBarGroups: Int,
	val customBarIndexes: Int,

	val itemBags: ImmutableMap<String, Bag>,
) {
	@JsonFactory
	class Bag(
		val priority: Int,
		val size: Int
	) {
		var name: String by WriteOnce()
	}

	init {
		for ((k, v) in itemBags) {
			v.name = k
		}
	}
}
