package ru.dbotthepony.kstarbound.defs.player

import com.google.common.collect.ImmutableList
import com.google.common.collect.ImmutableMap
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kvector.vector.Vector2d

@JsonFactory
data class StatusControllerSettings(
	val statusProperties: Properties,
	val appliesEnvironmentStatusEffects: Boolean = true,
	val appliesWeatherStatusEffects: Boolean = true,
	val minimumLiquidStatusEffectPercentage: Double = 0.1,

	val primaryScriptSources: ImmutableList<String> = ImmutableList.of(),

	val primaryScriptDelta: Int,

	val stats: ImmutableMap<String, Stat> = ImmutableMap.of(),
	val resources: ImmutableMap<String, Resource> = ImmutableMap.of(),
) {
	@JsonFactory
	data class Properties(
		val targetMaterialKind: String,
		val mouthPosition: Vector2d,
		val breathHealthPenaltyPercentageRate: Double,
		val hitInvulnerabilityThreshold: Double,
		val hitInvulnerabilityTime: Double,
		val hitInvulnerabilityFlash: Double,
		val shieldHitInvulnerabilityTime: Double,
		val damageFlashOnDirectives: String = "",
		val damageFlashOffDirectives: String = ""
	)

	@JsonFactory
	data class Stat(
		val baseValue: Double
	)

	@JsonFactory
	data class Resource(
		val maxStat: String? = null,
		val deltaStat: String? = null,
		val deltaValue: Double? = null,
		val initialPercentage: Double? = null,
		val initialValue: Double? = null,
	)
}
