package ru.dbotthepony.kstarbound.defs.quest

import com.google.common.collect.ImmutableSet
import com.google.gson.JsonObject
import ru.dbotthepony.kstarbound.defs.AssetPath
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory

@JsonFactory
data class QuestTemplate(
	val id: String,
	val prerequisites: ImmutableSet<String> = ImmutableSet.of(),
	val requiredItems: ImmutableSet<String> = ImmutableSet.of(),
	val script: AssetPath,
	val updateDelta: Int = 10,
	val moneyRange: LongRange,
	val scriptConfig: JsonObject = JsonObject()
)
