
message = {
	handlers = {}
}

local message = message

function message.setHandler(name, handler)
	if type(name) ~= 'string' then
		error('message.setHandler: Handler name must be a string, got ' .. type(name), 2)
	end

	if type(handler) ~= 'function' then
		error('message.setHandler: Handler itself must be a function, got ' .. type(handler), 2)
	end

	message.subscribe(name)
	message.handlers[name] = handler
end

function message.call(name, ...)
	local handler = message.handlers[name]

	if handler ~= nil then
		return handler(...)
	end
end
